/*
 * JTextAreaHandler.java
 * Copyright (C) 2007,2008 Lars Frantzen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

package jambition;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.ConsoleHandler;
import java.util.logging.LogRecord;
import javax.swing.JTextArea;

/**
 * 
 * @author Lars Frantzen
 * @version Plastic
 */
public class JTextAreaHandler extends ConsoleHandler {
    
    private JTextArea myjta;
    private DateFormat df = new SimpleDateFormat("dd'/'MM'/'yy' 'HH':'mm':'ss':'SSS");
    
    /** Creates a new instance of JTextAreaHandler */
    public JTextAreaHandler(JTextArea jta) {
        myjta = jta;
    }
    
    @Override
    public void publish(final LogRecord record) {
        final Date d = new Date();
        d.setTime(record.getMillis());
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                myjta.append(df.format(d) + ": ");
                myjta.append(record.getMessage() + '\n');
            }
        });
    }
    
}
